
' surface types
Const SF_NORMAL:Int=0
Const SF_LIGHTMAP:Int=1
Const SF_TANGENTS:Int=2

Type SURFACE
	Field _mbuf:IMeshBuffer=Null
	Field _type:Int
	Field _bReadOnly:Int=False
	
	Method Delete()
		_mbuf=Null
	EndMethod
	
	' TODO: dont think this is working right.  need to examine source of addTestSceneNode().
	Method addVertex:Int(x:Float,y:Float,z:Float,nx:Float=0,ny:Float=0,nz:Float=0,u:Float=0,v:Float=0)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
Rem
		Local vert:S3DVertex=S3DVertexDefault.createFromVals(x,y,z,nx,ny,nz,SColor.createFromVals(255,255,255,255),u,v)
		Local vert_array:S3DVertex[1] = vert
		'DebugLog("before: "+_mbuf.getVertices().size())
		_mbuf.getVertices().push_back(vert)
		'DebugLog("after: "+_mbuf.getVertices().size())
EndRem
		RuntimeError "Not Implemented"
		Return _mbuf.getVertexCount()-1
	EndMethod	

	' TODO: dont think this is working right.  need to examine source of addTestSceneNode().
	Method addTriangle(v0:Short,v1:Short,v2:Short)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
Rem
		Local indicies:Array_u16=_mbuf.getIndices()
		DebugLog("before: "+_mbuf.getIndices().size())
		indicies.push_back(v0)
		indicies.push_back(v1)
		indicies.push_back(v2)
		DebugLog("after: "+_mbuf.getIndices().size())
EndRem
		RuntimeError "Not Implemented"
	EndMethod	

	Method getVertexCount:Int()
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Return _mbuf.getVertexCount()
	EndMethod

	Method setVertexCoords(index:Int,x:Float,y:Float,z:Float)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=S3DVertex(_mbuf.getVertices()[index])
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		vertex.setPos(Vector3df.createFromVals(x,y,z))
	EndMethod
	
	Method setVertexNormal(index:Int,nx:Float,ny:Float,nz:Float)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		vertex.setNormal(Vector3df.createFromVals(nx,ny,nz))
	EndMethod
	
	Method setVertexColor(index:Int,red:Float,green:Float,blue:Float)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		vertex.setColor(SColorf.createFromRGB(red,green,blue).toSColor())
	EndMethod
	
	Method setVertexTexCoords(index:Int,u:Float,v:Float)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		vertex.setTCoords(Vector2df.createFromVals(u,v))
	EndMethod
	
	Method getVertexRed:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getColor().getRed()
	EndMethod
	
	Method getVertexGreen:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getColor().getGreen()
	EndMethod
	
	Method getVertexBlue:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getColor().getBlue()
	EndMethod

	Method getVertexX:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getPos().getX()
	EndMethod
	
	Method getVertexY:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getPos().getY()
	EndMethod
	
	Method getVertexZ:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getPos().getZ()
	EndMethod
								
	Method getVertexNX:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getNormal().getX()
	EndMethod
	
	Method getVertexNY:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getNormal().getY()
	EndMethod
	
	Method getVertexNZ:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getNormal().getZ()
	EndMethod

	Method getVertexU:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getTCoords().getX()
	EndMethod		

	Method getVertexV:Float(index:Int)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Local vertex:S3DVertex=_mbuf.getVertex(index)
		If Not vertex Or Not vertex.isValid() Then RuntimeError "Vertex not found"
		Return vertex.getTCoords().getY()
	EndMethod		

	Method getTriangleVertex:Int(triangle_index:Int,corner:Short)
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Return _mbuf.getIndices()[(triangle_index * 3) + corner]
	EndMethod	
    
    Method getTriangleCount:Int()
		If Not _mbuf Or Not _mbuf.isValid() Then RuntimeError "Surface meshbuffer is invalid"
		Return _mbuf.getIndexCount()/3
	EndMethod
EndType

' NOTE: can add to only SMesh based meshes
Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>mesh:MESH - an instance of a mesh to add the surface to</li>
</ul>
<details>
EndRem
Function ib3d_CreateSurface:SURFACE(mesh:MESH,surface_type:Int=SF_NORMAL)
	If Not _g_ib3d_engine Then RuntimeError "iB3D engine has not been initialized"
	If Not mesh Then RuntimeError "Mesh does not exist"
	Return _g_ib3d_engine.createSurface(mesh,surface_type)	
EndFunction

' TODO: dont think this is working right.  need to examine source of addTestSceneNode().
' NOTE new params
Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_AddVertex:Int(surf:SURFACE,x:Float,y:Float,z:Float,nx:Float=0,ny:Float=0,nz:Float=0,u:Float=0,v:Float=0)
	If Not surf Then RuntimeError "Surface does not exist" 
	Return surf.addVertex(x,y,z,nx,ny,nz,u,v)	
EndFunction

' TODO: dont think this is working right.  need to examine source of addTestSceneNode().
Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_AddTriangle(surf:SURFACE,v0:Short,v1:Short,v2:Short)
	If Not surf Then RuntimeError "Surface does not exist" 
	surf.addTriangle(v0,v1,v2)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_CountVertices:Int(surf:SURFACE)
	If Not surf Then RuntimeError "Surface does not exist" 
	Return surf.getVertexCount()
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_VertexCoords(surf:SURFACE,index:Int,x:Float,y:Float,z:Float)
	If Not surf Then RuntimeError "Surface does not exist"
	surf.setVertexCoords(index,x,y,z)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_VertexNormal(surf:SURFACE,index:Int,nx:Float,ny:Float,nz:Float)
	If Not surf Then RuntimeError "Surface does not exist"
	surf.setVertexNormal(index,nx,ny,nz)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_VertexColor(surf:SURFACE,index:Int,red:Float,green:Float,blue:Float)
	If Not surf Then RuntimeError "Surface does not exist"
	surf.setVertexColor(index,red,green,blue)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_VertexTexCoords(surf:SURFACE,index:Int,u:Float,v:Float)
	If Not surf Then RuntimeError "Surface does not exist"
	surf.setVertexTexCoords(index,u,v)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>
EndRem
Function ib3d_VertexRed:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexRed(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexGreen:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexGreen(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexBlue:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexBlue(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexX:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexX(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexY:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexY(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexZ:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexZ(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexNX:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexNX(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexNY:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexNY(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexNZ:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexNZ(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexU:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexU(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_VertexV:Float(surf:SURFACE,index:Int)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getVertexV(index)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_TriangleVertex:Int(surf:SURFACE,triangle_index:Int,corner:Short)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getTriangleVertex(triangle_index,corner)
EndFunction

Rem
bbdoc: <description>
returns: <what it returns>
about: <i>Parameters</i>
<ul>
<li>surf:SURFACE - an instance of a surface</li>
</ul>
<details>

EndRem
Function ib3d_CountTriangles:Int(surf:SURFACE)
	If Not surf Then RuntimeError "Surface does not exist"
	Return surf.getTriangleCount()
EndFunction

Rem
- Surface functions
CreateSurface - new SMeshBuffer -> can add to SMesh only!!
CountVertices - IMeshBuffer.getVertexCount()
VertexCoords - IMeshBuffer.getVertices().elementAt().setPos()
VertexNormal - IMeshBuffer.getVertices().elementAt().setNormal()
VertexColor - IMeshBuffer.getVertices().elementAt().setColor()
VertexTexCoords - IMeshBuffer.getVertices().elementAt().setTCoords()
VertexRed - IMeshBuffer.getVertices().elementAt().getColor().getRed()
VertexGreen - IMeshBuffer.getVertices().elementAt().getColor().getGreen()
VertexBlue - IMeshBuffer.getVertices().elementAt().getColor().getBlue()
VertexX - IMeshBuffer.getVertices().elementAt().getPos().getX()
VertexY - IMeshBuffer.getVertices().elementAt().getPos().getY()
VertexZ - IMeshBuffer.getVertices().elementAt().getPos().getZ()
VertexNX - IMeshBuffer.getVertices().elementAt().getNormal().getX()
VertexNY - IMeshBuffer.getVertices().elementAt().getNormal().getY()
VertexNZ - IMeshBuffer.getVertices().elementAt().getNormal().getZ()
VertexU - IMeshBuffer.getVertices().elementAt().getTCoords().getX()
VertexV - IMeshBuffer.getVertices().elementAt().getTCoords().getY()
VertexAlpha
CountTriangles - IMeshBuffer.getIndexCount()/3
TriangleVertex - IMeshBuffer.getIndices().elementAt()

- Not Converted:
PaintSurface - SMeshBuffer.getMaterial()
ClearSurface 
FindSurface 
VertexW 

- Not sure if working
AddVertex 
AddTriangle 

- Unsupported
VertexTexCoords optional parameters

EndRem
