'  ------------------------------------------------------------------------------------
'  irr::core::array<SParticle*> wrappers
'  NOTES:
'  - for regular data types use Var IrrCore_() to get the actual value
'  - did not implement:
	'Function IrrCore_Array_SParticle_ptr_linear_reverse_search:Int(parray_SParticle_ptr_arr:Int,find:Int)
	'Function IrrCore_Array_SParticle_ptr_linear_search:Int(parray_SParticle_ptr_arr:Int,find:Int)
	'Function IrrCore_Array_SParticle_ptr_binary_search:Int(parray_SParticle_ptr_arr:Int,find:Int)
	'Function IrrCore_Array_SParticle_ptr_binary_searchWithBounds:Int(parray_SParticle_ptr_arr:Int,find:Int,nLeft:Int,nRight:Int)
	'Function IrrCore_Array_SParticle_ptr_sort(parray_SParticle_ptr_arr:Int)
	'Function IrrCore_Array_SParticle_ptr_const_pointer:Int(parray_SParticle_ptr_arr:Int)
	'Function IrrCore_Array_SParticle_ptr_pointer:Int(parray_SParticle_ptr_arr:Int)
	'Function IrrCore_Array_SParticle_ptr_set_pointer(parray_SParticle_ptr_arr:Int,newPointer:Int,size:Int)
'  ------------------------------------------------------------------------------------

Public

Type Array_SParticle_ptr Extends IrrBase Final

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createWithSize:Array_SParticle_ptr(start_count:Int)
		Return createFromHandle(IrrCore_Array_SParticle_ptr_newWithSize(start_count))
	EndFunction
	
	Function createFromOther:Array_SParticle_ptr(other:Array_SParticle_ptr)
		Return createFromHandle(IrrCore_Array_SParticle_ptr_newFromOther(other.handle))
	EndFunction

	Function create:Array_SParticle_ptr()
		Return createFromHandle(IrrCore_Array_SParticle_ptr_new())
	EndFunction
	
	Function createFromHandle:Array_SParticle_ptr(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:Array_SParticle_ptr=New Array_SParticle_ptr
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Array_SParticle_ptr_del(handle)
	EndMethod	

	'--------------------------------------------
	' the rest
	'--------------------------------------------
	
	Method allocated_size:Int()
		Return IrrCore_Array_SParticle_ptr_allocated_size(handle)
	EndMethod

	Method clear()
		IrrCore_Array_SParticle_ptr_clear(handle)
	EndMethod

	Method empty:Int()
		Return IrrCore_Array_SParticle_ptr_empty(handle)
	EndMethod
	
	Method eraseWithCount(idx:Int,count:Int)
		IrrCore_Array_SParticle_ptr_eraseWithCount(handle,idx,count)
	EndMethod
	
	Method erase(idx:Int)
		IrrCore_Array_SParticle_ptr_erase(handle,idx)
	EndMethod

	Method reallocate(new_size:Int)
		IrrCore_Array_SParticle_ptr_reallocate(handle,new_size)
	EndMethod
	
	Method set_free_when_destroyed(bNewVal:Int)
		IrrCore_Array_SParticle_ptr_set_free_when_destroyed(handle,bNewVal)
	EndMethod

	Method set_sorted(bVal:Int)
		IrrCore_Array_SParticle_ptr_set_sorted(handle,bVal)
	EndMethod
	
	Method set_used(used:Int)
		IrrCore_Array_SParticle_ptr_set_used(handle,used)
	EndMethod
	
	Method size:Int()
		Return IrrCore_Array_SParticle_ptr_size(handle)
	EndMethod

	Method getLast:SParticle()
		'  do Not Delete this pointer
		Return SParticle.createFromHandle(IrrCore_Array_SParticle_ptr_getLast(handle),False)
	EndMethod

	Method elementAt:SParticle(idx:Int)
		'  do Not Delete this pointer
		Return SParticle.createFromHandle(IrrCore_Array_SParticle_ptr_elementAt(handle,idx),False)
	EndMethod
	
	Method insert(element:SParticle,idx:Int=0)
		IrrCore_Array_SParticle_ptr_insert(handle,element.handle,idx)
	EndMethod

	Method Eq(other:Array_SParticle_ptr)
		IrrCore_Array_SParticle_ptr_Eq(handle,other.handle)
	EndMethod

	Method push_back(element:SParticle)
		IrrCore_Array_SParticle_ptr_push_back(handle,element.handle)
	EndMethod
	
	Method push_front(element:SParticle)
		IrrCore_Array_SParticle_ptr_push_front(handle,element.handle)
	EndMethod
		
EndType





