'  ------------------------------------------------------------------------------------
'  irr::core::array<u32> wrappers
'  NOTES:
'  - for regular data types use Var IrrCore_() to get the actual value
'  - did not implement:
	'Function IrrCore_Array_u32_const_pointer:Float Ptr(parray_u32_arr:Int)
	'Function IrrCore_Array_u32_pointer:Float Ptr(parray_u32_arr:Int)
	'Function IrrCore_Array_u32_set_pointer(parray_u32_arr:Int,newPointer:Float Ptr,size:Int)
'  ------------------------------------------------------------------------------------

Public

Type Array_u32 Extends IrrBase Final


	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createWithSize:Array_u32(start_count:Int)
		Return createFromHandle(IrrCore_Array_u32_newWithSize(start_count))
	EndFunction
	
	Function createFromOther:Array_u32(other:Array_u32)
		Return createFromHandle(IrrCore_Array_u32_newFromOther(other.handle))
	EndFunction

	Function create:Array_u32()
		Return createFromHandle(IrrCore_Array_u32_new())
	EndFunction
	
	Function createFromHandle:Array_u32(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:Array_u32=New Array_u32
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Array_u32_del(handle)
	EndMethod	

	'--------------------------------------------
	' the rest
	'--------------------------------------------

	Method allocated_size:Int()
		Return IrrCore_Array_u32_allocated_size(handle)
	EndMethod

	Method clear()
		IrrCore_Array_u32_clear(handle)
	EndMethod

	Method empty:Int()
		Return IrrCore_Array_u32_empty(handle)
	EndMethod
	
	Method eraseWithCount(idx:Int,count:Int)
		IrrCore_Array_u32_eraseWithCount(handle,idx,count)
	EndMethod
	
	Method erase(idx:Int)
		IrrCore_Array_u32_erase(handle,idx)
	EndMethod
	
	Method getLast:Float Ptr()
		' TODO: look into this
		'Return Var IrrCore_Array_u32_getLast(handle)
		Return IrrCore_Array_u32_getLast(handle)
	EndMethod
	
	Method elementAt:Float Ptr(idx:Int)
		' TODO: look into this
		'Return Var IrrCore_Array_u32_elementAt(handle,idx)
		Return IrrCore_Array_u32_elementAt(handle,idx)
	EndMethod
	
	Method insert(element:Float,idx:Int=0)
		IrrCore_Array_u32_insert(handle,Varptr(element),idx)
	EndMethod
	
	Method Eq(other:Array_u32)
		IrrCore_Array_u32_Eq(handle,other.handle)
	EndMethod

	Method push_back(element:Float)
		IrrCore_Array_u32_push_back(handle,Varptr(element))
	EndMethod
	
	Method push_front(element:Float)
		IrrCore_Array_u32_push_front(handle,Varptr(element))
	EndMethod

	Method reallocate(new_size:Int)
		IrrCore_Array_u32_reallocate(handle,new_size)
	EndMethod
	
	Method set_free_when_destroyed(bNewVal:Int)
		IrrCore_Array_u32_set_free_when_destroyed(handle,bNewVal)
	EndMethod

	Method set_sorted(bVal:Int)
		IrrCore_Array_u32_set_sorted(handle,bVal)
	EndMethod
	
	Method set_used(used:Int)
		IrrCore_Array_u32_set_used(handle,used)
	EndMethod
	
	Method size:Int()
		Return IrrCore_Array_u32_size(handle)
	EndMethod

	Method linear_reverse_search:Int(find:Float)
		Return IrrCore_Array_u32_linear_reverse_search(handle,Varptr(find))
	EndMethod

	Method linear_search:Int(find:Float)
		Return IrrCore_Array_u32_linear_search(handle,Varptr(find))
	EndMethod

	Method binary_search:Int(find:Float)
		Return IrrCore_Array_u32_binary_search(handle,Varptr(find))
	EndMethod

	Method binary_searchWithBounds:Int(find:Float,nLeft:Int,nRight:Int)
		Return IrrCore_Array_u32_binary_searchWithBounds(handle,Varptr(find),nLeft,nRight)
	EndMethod

	Method sort()
		IrrCore_Array_u32_sort(handle)
	EndMethod
	
EndType



