' ------------------------------------------------------------------------------------
' irr::core::stringw wrappers
' ------------------------------------------------------------------------------------
Public

Type StringW Extends IrrBase Final

	Method EqEqStringW:Int(pOther:StringW)
		Return IrrCore_StringW_EqEqStringW(handle,pOther.handle)
	EndMethod

	Method EqEq:Int(other:String)
		Return IrrCore_StringW_EqEq(handle,StringToWChar(other))
	EndMethod

	Method NotEq:Int(pOther:StringW)
		Return IrrCore_StringW_NotEq(handle,pOther.handle)
	EndMethod
	
	Method Less:Int(pOther:StringW)
		Return IrrCore_StringW_Less(handle,pOther.handle)
	EndMethod

	Method PlusEqChar(char:Short)
		IrrCore_StringW_PlusEqChar(handle,char)
	EndMethod
	
	Method PlusEqString(pOther:StringW)
		IrrCore_StringW_PlusEqString(handle,pOther.handle)
	EndMethod
	
	Method PlusEqInt(i:Int)
		IrrCore_StringW_PlusEqInt(handle,i)
	EndMethod

	Method Eq(pOther:StringW)
		IrrCore_StringW_Eq(handle,pOther.handle)
	EndMethod

	Method EqStringPtr(pOther:Short Ptr)
		IrrCore_StringW_EqStringPtr(handle,pOther)
	EndMethod

	Method EqString(str:String)
		IrrCore_StringW_EqStringPtr(handle,StringToWChar(str))
	EndMethod

	Method PlusStringPtr:StringW(pOther:Short Ptr)
		Return createFromHandle(IrrCore_StringW_PlusStringPtr(handle,pOther))
	EndMethod
	
	Method Plus:StringW(pOther:StringW)
		Return createFromHandle(IrrCore_StringW_Plus(handle,pOther.handle))
	EndMethod

	Method idx:Short(idx:Int)
		Return IrrCore_StringW_idx(handle,idx)
	EndMethod

	Method idx_s:String(idx:Int)
		Return Chr(IrrCore_StringW_idx(handle,idx))
	EndMethod

	Method equals_ignore_case:Int(pOther:StringW)
		Return IrrCore_StringW_equals_ignore_case(handle,pOther.handle)
	EndMethod

	Method equalsnStringW:Int(pOther:StringW,strlen:Int)
		Return IrrCore_StringW_equalsnStringW(handle,pOther.handle,strlen)
	EndMethod

	Method equalsn:Int(other:String,strlen:Int)
		Return IrrCore_StringW_equalsn(handle,StringToWChar(other),strlen)
	EndMethod

	Method reserve(count:Int)
		IrrCore_StringW_reserve(handle,count)
	EndMethod

	Method findFirst:Int(char:Short)
		Return IrrCore_StringW_findFirst(handle,char)
	EndMethod
	
	Method findNext:Int(char:Short,startpos:Int)
		Return IrrCore_StringW_findNext(handle,char,startpos)
	EndMethod

	Method findLast:Int(char:Short)
		Return IrrCore_StringW_findLast(handle,char)
	EndMethod
	
	Method find:Int(other:Short Ptr)
		Return IrrCore_StringW_find(handle,other)
	EndMethod
	
	Method subString:StringW(begin:Int,length:Int)
		Return createFromHandle(IrrCore_StringW_subString(handle,begin,length))
	EndMethod
	
	Method appendString(str:String)
		IrrCore_StringW_appendStringW(handle,createFromString(str).handle)
	EndMethod

	Method appendStringWithLength(str:String,length:Int)
		IrrCore_StringW_appendStringWWithLength(handle,createFromString(str).handle,length)
	EndMethod

	Method appendChar(char:Short)
		IrrCore_StringW_appendChar(handle,char)
	EndMethod
	
	Method appendStringW(pOther:StringW)
		IrrCore_StringW_appendStringW(handle,pOther.handle)
	EndMethod

	Method appendStringWWithLength(pOther:StringW,length:Int)
		IrrCore_StringW_appendStringWWithLength(handle,pOther.handle,length)
	EndMethod

	Method getString:String()
		Return WCharToString(c_str())
	EndMethod
	
	Method c_str:Byte Ptr()
		Return IrrCore_StringW_c_str(handle)
	EndMethod

	Method make_lower()
		IrrCore_StringW_make_lower(handle)
	EndMethod

	Method make_upper()
		IrrCore_StringW_make_upper(handle)
	EndMethod

	Method size:Int()
		Return IrrCore_StringW_size(handle)
	EndMethod

	Method PlusEqCharString(other:Short Ptr)
		IrrCore_StringW_PlusEqcharString(handle,other)
	EndMethod
	
	Method PlusEqDouble(i:Double)
		IrrCore_StringW_PlusEqDouble(handle,i)
	EndMethod
	
	Method appendCharString(other:Short Ptr)
		IrrCore_StringW_appendCharString(handle,other)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createFromString:StringW(str:String)
		Return createFromStringPtr(IrrBase.StringToWChar(str))
	EndFunction

	Function createFromStringW:StringW(pOther:StringW)
		Return createFromHandle(IrrCore_StringW_newFromStringW(pOther.handle))
	EndFunction
	
	Function createFromInt:StringW(number:Int)
		Return createFromHandle(IrrCore_StringW_newFromInt(number))
	EndFunction
	
	Function createFromStringPtr:StringW(pOther:Byte Ptr)
		Return createFromHandle(IrrCore_StringW_newFromStringPtr(pOther))
	EndFunction

	Function createFromStringPtrWithLength:StringW(pOther:Byte Ptr,length:Int)
		Return createFromHandle(IrrCore_StringW_newFromStringPtrWithLength(pOther,length))
	EndFunction

	Function create:StringW()
		Return createFromHandle(IrrCore_StringW_new())
	EndFunction
		
	Function createFromHandle:StringW(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:StringW=New StringW
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_StringW_del(handle)
	EndMethod	

EndType
