' ------------------------------------------------------------------------------------
' irr::io::IFileList wrappers
' be sure to call the drop function when done 
' ------------------------------------------------------------------------------------
Public

Type IFileList Extends IReferenceCounted Final

	Function createFromHandle:IFileList(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IFileList=New IFileList
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getFileCount:Int()	
		Return IrrIO_IFileList_getFileCount(handle)
	EndMethod
	
	Method getFileName:String(idx:Int)
		Return String.FromCString(IrrIO_IFileList_getFileName(handle,idx))
	EndMethod
	
	Method getFullFileName:String(idx:Int)
		Return String.FromCString(IrrIO_IFileList_getFullFileName(handle,idx))
	EndMethod
	
	Method isDirectory:Int(idx:Int)
		Return IrrIO_IFileList_isDirectory(handle,idx)
	EndMethod

	Method findFile:Int(filename:String, bIsFolder:Int = False)
		Return IrrIO_IFileList_findFile(handle, filename, bIsFolder) 
	EndMethod
	
	Method getPath:String()
		Return IrrIO_IFileList_getPath(handle)
	EndMethod

	Method getID:Int(index:Int)
		Return IrrIO_IFileList_getID(handle, index) 
	EndMethod
	
	Method addItem:Int(fullPath:String, size:Int, bIsDirectory:Int, id:Int = 0)
		Return IrrIO_IFileList_addItem(handle, fullPath, size, bIsDirectory, id)
	EndMethod
	
	Method sort()
		IrrIO_IFileList_sort(handle)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IFileList_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IFileList_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IFileList_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

EndType


