' ------------------------------------------------------------------------------------
' irr::io::IXMLReader wrappers
' be sure To call the drop Function when done
'------------------------------------------------------------------------------------
Public

Type IXMLReader Extends IReferenceCounted Final

	Function createFromHandle:IXMLReader(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IXMLReader=New IXMLReader
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getAttributeCount:Int()
		Return IrrIO_IXMLReader_getAttributeCount(handle)
	EndMethod
	
	Method getAttributeName:String(idx:Int)
		Return IrrIO_IXMLReader_getAttributeName(handle,idx)
	EndMethod
	
	Method getAttributeValue:String(name:String)
		Return IrrIO_IXMLReader_getAttributeValue(handle,name)
	EndMethod 

	Method getAttributeValueByIdx:String(idx:Int)
		Return IrrIO_IXMLReader_getAttributeValueByIdx(handle,idx)
	EndMethod
	
	Method getAttributeValueAsFloat:Float(name:String)
		Return IrrIO_IXMLReader_getAttributeValueAsFloat(handle,name)
	EndMethod
	
	Method getAttributeValueAsFloatByIdx:Float(idx:Int)
		Return IrrIO_IXMLReader_getAttributeValueAsFloatByIdx(handle,idx)
	EndMethod
	
	Method getAttributeValueAsInt:Int(name:String)
		Return IrrIO_IXMLReader_getAttributeValueAsInt(handle,name)
	EndMethod
	
	Method getAttributeValueAsIntByIdx:Int(idx:Int)
		Return IrrIO_IXMLReader_getAttributeValueAsIntByIdx(handle,idx)
	EndMethod

	Method getAttributeValueSafe:String(handle:Int,name:String)
		Return IrrIO_IXMLReader_getAttributeValueSafe(handle,name)
	EndMethod
	
	Method getNodeData:String()
		Return IrrIO_IXMLReader_getNodeData(handle).Replace(Chr(13),"")
	EndMethod
	
	Method getNodeName:String()
		Return IrrIO_IXMLReader_getNodeName(handle)
	EndMethod
	
	Method getNodeType:String()
		Return IrrIO_IXMLReader_getNodeType(handle)
	EndMethod
	
	Method IsEmptyElement:Int()
		Return IrrIO_IXMLReader_isEmptyElement(handle)
	EndMethod
	
	Method read:Int()
		Return IrrIO_IXMLReader_read(handle)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IXMLReader_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IXMLReader_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IXMLReader_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType



