' ------------------------------------------------------------------------------------
' irr::ITimer wrappers
' ------------------------------------------------------------------------------------
Public

Type ITimer Extends IReferenceCounted Final

	Function createFromHandle:ITimer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:ITimer=New ITimer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getTime:Int()
		Return Irr_ITimer_getTime(handle)
	EndMethod

	Method getRealTime:Int()
		Return Irr_ITimer_getRealTime:Int(handle)
	EndMethod
	
	Method setTime(time:Int)
		Irr_ITimer_setTime(handle,time)
	EndMethod
	
	Method stop()
		Irr_ITimer_stop(handle)
	EndMethod
	
	Method start()
		Irr_ITimer_start(handle)
	EndMethod
	
	Method setSpeed(speed:Float=1.0)
		Irr_ITimer_setSpeed(handle,speed)
	EndMethod
	
	Method getSpeed:Float()
		Return Irr_ITimer_getSpeed(handle)
	EndMethod 
	
	Method isStopped:Int()
		Return Irr_ITimer_isStopped(handle)
	EndMethod
	
	Method tick()
		Irr_ITimer_tick(handle)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return Irr_ITimer_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return Irr_ITimer_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		Irr_ITimer_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
EndType


