Public

Type IIndexBuffer Extends IReferenceCounted

	Function createFromHandle:IIndexBuffer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IIndexBuffer=New IIndexBuffer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getData:Byte Ptr()
		Return IrrScene_IIndexBuffer_getData(handle)
	EndMethod
	
	Method getType:Int() ' returns E_INDEX_TYPE
		Return IrrScene_IIndexBuffer_getType(handle)
	EndMethod 
	
	Method setType(E_INDEX_TYPE:Int)
		IrrScene_IIndexBuffer_setType(handle, E_INDEX_TYPE)
	EndMethod
	
	Method stride:Int()
		Return IrrScene_IIndexBuffer_stride(handle)
	EndMethod
	
	Method size:Int()
		Return IrrScene_IIndexBuffer_size(handle)
	EndMethod
	
	Method push_back(element:Int)
		IrrScene_IIndexBuffer_push_back(handle, element)
	EndMethod
	
	Method elementAt:Int(index:Int)
		Return IrrScene_IIndexBuffer_elementAt(handle, index)
	EndMethod
	
	Method getLast:Int()
		Return IrrScene_IIndexBuffer_getLast(handle)
	EndMethod
	
	Method setValue(index:Int, value:Int)
		IrrScene_IIndexBuffer_setValue(handle, index, value)
	EndMethod
	
	Method set_used(usedNow:Int)
		IrrScene_IIndexBuffer_set_used(handle, usedNow)
	EndMethod
	
	Method reallocate(new_size:Int)
		IrrScene_IIndexBuffer_reallocate(handle, new_size)
	EndMethod
	
	Method allocated_size:Int()
		Return IrrScene_IIndexBuffer_allocated_size(handle)
	EndMethod
	
	Method pointer:Byte Ptr()
		Return IrrScene_IIndexBuffer_pointer(handle)
	EndMethod
	
	Method getHardwareMappingHint:Int() ' returns E_HARDWARE_MAPPING 
		Return IrrScene_IIndexBuffer_getHardwareMappingHint(handle)
	EndMethod
	
	Method setHardwareMappingHint(E_HARDWARE_MAPPING:Int)
		IrrScene_IIndexBuffer_setHardwareMappingHint(handle, E_HARDWARE_MAPPING)
	EndMethod
	
	Method setDirty()
		IrrScene_IIndexBuffer_setDirty(handle)
	EndMethod
	
	Method getChangedID:Int()
		Return IrrScene_IIndexBuffer_getChangedID(handle)
	EndMethod

	Method drop:Int()
		If mustdelete Then mustdelete=False		
		Return IrrScene_IIndexBuffer_drop(handle)
	EndMethod
	
	Method getDebugName:String()
		Return IrrScene_IIndexBuffer_getDebugName(handle)
	EndMethod
	
	Method grab()
		IrrScene_IIndexBuffer_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType

