' ------------------------------------------------------------------------------------
' irr::scene::IParticleEmitter wrappers
' TODO: make bound version
' ------------------------------------------------------------------------------------
Public

Type IParticleEmitter Extends IAttributeExchangingObject

	Function createFromHandle:IParticleEmitter(pHandle:Int,bMustDel:Int=True,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IParticleEmitter=New IParticleEmitter
		oRetVal.attach(pHandle,bMustDel)
		oRetVal=oRetVal.cast(True)		
		Return oRetVal
	EndFunction

	Method cast:IParticleEmitter(bTakeOwnership:Int=True)
		Local emitter_cast:IParticleEmitter=Null
		Local emitter_type:Int=getType()
		Local bMustDelete:Int=False

		If bTakeOwnership Then 
			bMustDelete=Self.mustdelete
			Self.mustdelete=False
		EndIf

		' cast to specific emitter type
		Select emitter_type
			Case EPET_ANIMATED_MESH
				emitter_cast = IParticleAnimatedMeshSceneNodeEmitter.createFromHandle(Self.handle,bMustDelete)
			Case EPET_BOX
				emitter_cast = IParticleBoxEmitter.createFromHandle(Self.handle,bMustDelete)
			Case EPET_CYLINDER
				emitter_cast = IParticleCylinderEmitter.createFromHandle(Self.handle,bMustDelete)
			Case EPET_MESH
				emitter_cast = IParticleMeshEmitter.createFromHandle(Self.handle,bMustDelete)
			Case EPET_RING
				emitter_cast = IParticleRingEmitter.createFromHandle(Self.handle,bMustDelete)
			Case EPET_SPHERE
				emitter_cast = IParticleSphereEmitter.createFromHandle(Self.handle,bMustDelete)
			Default
				emitter_cast=Self
				Self.mustdelete=bMustDelete
		EndSelect

		Return emitter_cast
	EndMethod
	
	Method emitt:Array_SParticle(now:Int,timeSinceLastCall:Int)
		Return Array_SParticle.createFromHandle(IrrScene_IParticleEmitter_emitt(handle,now,timeSinceLastCall))
	EndMethod

	Method setDirection(newDirection:Vector3df)
		IrrScene_IParticleEmitter_setDirection( handle, newDirection.handle )
	EndMethod
	
	Method setMinParticlesPerSecond(minPPS:Int)
		IrrScene_IParticleEmitter_setMinParticlesPerSecond( handle, minPPS )
	EndMethod
	
	Method setMaxParticlesPerSecond(maxPPS:Int)
		IrrScene_IParticleEmitter_setMaxParticlesPerSecond( handle, maxPPS )
	EndMethod
	
	Method setMinStartColor(color:SColor)
		IrrScene_IParticleEmitter_setMinStartColor( handle, color.handle )
	EndMethod
	
	Method setMaxStartColor(color:SColor)
		IrrScene_IParticleEmitter_setMaxStartColor( handle, color.handle )
	EndMethod

	Method getDirection:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_IParticleEmitter_getDirection(handle), True)
	EndMethod
	
	Method getMinParticlesPerSecond:Int()
		Return IrrScene_IParticleEmitter_getMinParticlesPerSecond(handle)
	EndMethod
	
	Method getMaxParticlesPerSecond:Int()
		Return IrrScene_IParticleEmitter_getMaxParticlesPerSecond(handle)
	EndMethod
	
	Method getMinStartColor:SColor()
		Return SColor.createFromHandle(IrrScene_IParticleEmitter_getMinStartColor(handle), True)
	EndMethod
	
	Method getMaxStartColor:SColor()
		Return SColor.createFromHandle(IrrScene_IParticleEmitter_getMaxStartColor(handle), True)
	EndMethod
	
	Method getType:Int() ' returns E_PARTICLE_EMITTER_TYPE
		Return IrrScene_IParticleEmitter_getType(handle) 
	EndMethod
	
	Method drop:Int()
		If mustdelete Then mustdelete=False		
		Return IrrScene_IParticleEmitter_drop(handle)
	EndMethod
	
	Method getDebugName:String()
		Return IrrScene_IParticleEmitter_getDebugName(handle)
	EndMethod
	
	Method grab()
		IrrScene_IParticleEmitter_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
	
	Method getMaxStartSize:Dimension2df()
		Return Dimension2df.createFromHandle(IrrScene_IParticleEmitter_getMaxStartSize(handle), True)
	EndMethod
	
	Method getMinStartSize:Dimension2df()
		Return Dimension2df.createFromHandle(IrrScene_IParticleEmitter_getMinStartSize(handle), True)
	EndMethod
	
	Method setMaxStartSize(size:Dimension2df)
		IrrScene_IParticleEmitter_setMaxStartSize(handle, size.handle)
	EndMethod
	
	Method setMinStartSize(size:Dimension2df)
		IrrScene_IParticleEmitter_setMinStartSize(handle, size.handle)
	EndMethod
	
EndType
