Public

Type IVertexBuffer Extends IReferenceCounted

	Function createFromHandle:IVertexBuffer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IVertexBuffer=New IVertexBuffer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getData:Byte Ptr()
		Return IrrScene_IVertexBuffer_getData(handle)
	EndMethod
	
	Method getType:Int() ' returns E_VERTEX_TYPE
		Return IrrScene_IVertexBuffer_getType(handle)
	EndMethod 
	
	Method setType(E_VERTEX_TYPE:Int)
		IrrScene_IVertexBuffer_setType(handle, E_VERTEX_TYPE)
	EndMethod
	
	Method stride:Int()
		Return IrrScene_IVertexBuffer_stride(handle)
	EndMethod
	
	Method size:Int()
		Return IrrScene_IVertexBuffer_size(handle)
	EndMethod
	
	Method push_back(element:S3DVertex)
		IrrScene_IVertexBuffer_push_back(handle, element.handle)
	EndMethod
	
	Method elementAt:S3DVertex(index:Int)
		Return S3DVertex.createFromHandle(IrrScene_IVertexBuffer_elementAt(handle, index), False)
	EndMethod
	
	Method getLast:S3DVertex()
		Return S3DVertex.createFromHandle(IrrScene_IVertexBuffer_getLast(handle), False)
	EndMethod
		
	Method set_used(usedNow:Int)
		IrrScene_IVertexBuffer_set_used(handle, usedNow)
	EndMethod
	
	Method reallocate(new_size:Int)
		IrrScene_IVertexBuffer_reallocate(handle, new_size)
	EndMethod
	
	Method allocated_size:Int()
		Return IrrScene_IVertexBuffer_allocated_size(handle)
	EndMethod
	
	Method pointer:S3DVertex[]()
		Local ptrs:Int Ptr
		Local objs:S3DVertex[] = Null				

		Local size:Int = IrrScene_IVertexBuffer_pointerOut(handle, Varptr(ptrs))

		If size>0 Then		
			objs = New S3DVertex[size]

			For Local i:Int=0 Until size
				objs[i] = S3DVertex.createFromHandle(ptrs[i], False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		Return objs	
	EndMethod
	
	Method getHardwareMappingHint:Int() ' returns E_HARDWARE_MAPPING 
		Return IrrScene_IVertexBuffer_getHardwareMappingHint(handle)
	EndMethod
	
	Method setHardwareMappingHint(E_HARDWARE_MAPPING:Int)
		IrrScene_IVertexBuffer_setHardwareMappingHint(handle, E_HARDWARE_MAPPING)
	EndMethod
	
	Method setDirty()
		IrrScene_IVertexBuffer_setDirty(handle)
	EndMethod
	
	Method getChangedID:Int()
		Return IrrScene_IVertexBuffer_getChangedID(handle)
	EndMethod

	Method drop:Int()
		If mustdelete Then mustdelete=False		
		Return IrrScene_IVertexBuffer_drop(handle)
	EndMethod
	
	Method getDebugName:String()
		Return IrrScene_IVertexBuffer_getDebugName(handle)
	EndMethod
	
	Method grab()
		IrrScene_IVertexBuffer_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType

