Public

Extern 

	' ------------------------------------------------------------------------------------
	' irr::video::SColor Function wrappers
	' ------------------------------------------------------------------------------------
	
	Function IrrVideo_Func_RGB16:Short(r:Int,g:Int,b:Int)
	Function IrrVideo_Func_RGBA16:Short(r:Int,g:Int,b:Int,a:Int)
	Function IrrVideo_Func_X8R8G8B8toA1R5G5B5:Short(color:Int)
	Function IrrVideo_Func_A8R8G8B8toR5G6B5:Short(color:Int) 
	Function IrrVideo_Func_getAlpha:Int(color:Short)
	Function IrrVideo_Func_getRed:Int(color:Short)
	Function IrrVideo_Func_getGreen:Int(color:Short)
	Function IrrVideo_Func_getBlue:Int(color:Short)
	Function IrrVideo_Func_A1R5G5B5toA8R8G8B8:Int(color:Short)
	Function IrrVideo_Func_A8R8G8B8toA1R5G5B5:Short(color:Int)
	Function IrrVideo_Func_R5G6B5toA8R8G8B8:Int(color:Short)
	Function IrrVideo_Func_R5G6B5toA1R5G5B5:Short(color:Short)
	Function IrrVideo_Func_A1R5G5B5toR5G6B5:Short(color:Short)
	Function IrrVideo_Func_RGB16from16:Short(r:Short,g:Short,b:Short)
	Function IrrVideo_Func_getAverage:Int(color:Short)

	' ------------------------------------------------------------------------------------
	' irr::video::SColor wrappers
	' ------------------------------------------------------------------------------------
	
	Function IrrVideo_SColor_new:Int() ' returns SColor*
	Function IrrVideo_SColor_newFromVals:Int(a:Int,r:Int,g:Int,b:Int) ' returns SColor*
	Function IrrVideo_SColor_newFromColorVal(color:Int) ' returns SColor*
	Function IrrVideo_SColor_del(pSColor:Int)
	Function IrrVideo_SColor_getAlpha:Int(pSColor:Int)
	Function IrrVideo_SColor_getRed:Int(pSColor:Int)
	Function IrrVideo_SColor_getGreen:Int(pSColor:Int)
	Function IrrVideo_SColor_getBlue:Int(pSColor:Int)
	Function IrrVideo_SColor_setAlpha(pSColor:Int,a:Int)
	Function IrrVideo_SColor_setRed(pSColor:Int,r:Int)
	Function IrrVideo_SColor_setGreen(pSColor:Int,g:Int)
	Function IrrVideo_SColor_setBlue(pSColor:Int,b:Int)
	Function IrrVideo_SColor_toA1R5G5B5:Short(pSColor:Int)
	Function IrrVideo_SColor_toOpenGLColor(pSColor:Int,oglColor:Byte Ptr) ' oglColor is a 4 char array
	Function IrrVideo_SColor_set(pSColor:Int,a:Int,r:Int,g:Int,b:Int)
	Function IrrVideo_SColor_EqEq:Int(pSColor:Int,pSColor_other:Int)
	Function IrrVideo_SColor_NotEq:Int(pSColor:Int,pSColor_other:Int)
	' must delete
	Function IrrVideo_SColor_plus:Int(pSColor:Int,pSColor_other:Int) ' returns SColor*
	Function IrrVideo_SColor_getInterpolated:Int(pSColor:Int,pSColor_other:Int,d:Float) ' returns SColor*
	Function IrrVideo_SColor_getColor:Int(pSColor:Int)
	Function IrrVideo_SColor_getLuminance:Float(pSColor:Int)
	Function IrrVideo_SColor_getAverage:Int(pSColor:Int)
	' must delete ptr
	Function IrrVideo_SColor_getInterpolated_quadratic:Int(pSColor:Int,pSColor_c1:Int,pSColor_c2:Int,d:Float) ' returns SColor*
	Function IrrVideo_SColor_getLightness:Float(pSColor:Int)
	
	' ------------------------------------------------------------------------------------
	' irr::video::SColorf wrappers
	' ------------------------------------------------------------------------------------
	
	Function IrrVideo_SColorf_new:Int() ' returns SColorf*
	Function IrrVideo_SColorf_newFromRGB:Int(r:Float,g:Float,b:Float) ' returns SColorf*
	Function IrrVideo_SColorf_newFromRGBA:Int(r:Float,g:Float,b:Float,a:Float=1.0) ' returns SColorf*
	Function IrrVideo_SColorf_newFromSColor:Int(pSColor:Int) ' returns SColorf*
	Function IrrVideo_SColorf_del(pSColorf:Int)
	Function IrrVideo_SColorf_toSColor:Int(pSColorf:Int) ' returns SColor*
	Function IrrVideo_SColorf_set(pSColorf:Int,rr:Float,gg:Float,bb:Float)
	Function IrrVideo_SColorf_setWithAlpha(pSColorf:Int,aa:Float,rr:Float,gg:Float,bb:Float)
	Function IrrVideo_SColorf_getAlpha:Float(pSColorf:Int)
	Function IrrVideo_SColorf_getRed:Float(pSColorf:Int)
	Function IrrVideo_SColorf_getGreen:Float(pSColorf:Int)
	Function IrrVideo_SColorf_getBlue:Float(pSColorf:Int)
	Function IrrVideo_SColorf_getArray:Float Ptr(pSColorf_color:Int) ' f32*
	Function IrrVideo_SColorf_getInterpolated:Int(pSColorf:Int,pSColorf_other:Int,d:Float) ' returns SColorf*
	Function IrrVideo_SColorf_setColorComponentValue(pSColorf:Int,index:Int,value:Float)
	' must delete ptr
	Function IrrVideo_SColorf_getInterpolated_quadratic:Int(pSColorf:Int,pSColorf_c1:Int,pSColorf_c2:Int,d:Float) ' returns SColorf*

	' ------------------------------------------------------------------------------------
	' irr::video::SColorHSL wrappers
	' ------------------------------------------------------------------------------------

	Function IrrVideo_SColorHSL_new:Int(h:Float=0,s:Float=0,l:Float=0 ) ' returns SColorHSL*
	Function IrrVideo_SColorHSL_del(pSColorHSL:Int)
	Function IrrVideo_SColorHSL_toRGB(pSColorHSL:Int,pSColor:Int)

EndExtern

